fLoadTexture proto hBmp:dword,Wrap:dword

fMat4 struct
	data real4 16 dup (0.0)
fMat4 ends

.data
;	m fMat4 <?>
.code

fFillMatrix4f proc uses esi lpfMat4:dword,nIndex:dword,lpValueReal4:dword
	
	mov esi,lpfMat4
	mov ecx,nIndex
	mov eax,lpValueReal4
	mov eax,[eax]
	mov [esi+ecx*4],eax
	
	ret
fFillMatrix4f endp

nwGlobalRotation proc uses esi edi ebx lpfMat4X:dword,lpfMat4Y:dword,lpfMat4Z:dword,lpLength:dword
	;Originally created by NightWare at www.masmforum.com
	
	; eax = OFFSET of X rotation matrix ) must be 4*4 matrix (even if we only use 3*3)
	; ebx = OFFSET of Y rotation matrix )
	; ecx = OFFSET of Z rotation matrix )
	; edx = OFFSET of the point to calc
	movaps XMM0,OWORD PTR [ecx]
	movaps XMM1,OWORD PTR [ecx+4*DWORD]
	movaps XMM2,OWORD PTR [ecx+8*DWORD]
	movaps XMM5,OWORD PTR [eax]
	movaps XMM6,OWORD PTR [eax+4*DWORD]
	movaps XMM7,OWORD PTR [ecx+8*DWORD]
	movaps XMM3,XMM0
	movaps XMM4,XMM0
	shufps XMM0,XMM0,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM0,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM0,XMM3
	addps XMM0,XMM4
	movaps XMM3,XMM1
	movaps XMM4,XMM1
	shufps XMM1,XMM1,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM1,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM1,XMM3
	addps XMM1,XMM4
	movaps XMM3,XMM2
	movaps XMM4,XMM2
	shufps XMM2,XMM2,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM2,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM2,XMM3
	addps XMM2,XMM4
	movaps XMM6,OWORD PTR [ebx]
	movaps XMM7,OWORD PTR [ebx+4*DWORD]
	movaps XMM5,OWORD PTR [ebx+8*DWORD]
	movaps XMM3,XMM6
	movaps XMM4,XMM6
	shufps XMM6,XMM6,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM6,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM6,XMM3
	addps XMM6,XMM4
	movaps XMM3,XMM7
	movaps XMM4,XMM7
	shufps XMM7,XMM7,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM7,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM7,XMM3
	addps XMM7,XMM4
	movaps XMM3,XMM5
	movaps XMM4,XMM5
	shufps XMM5,XMM5,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM5,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM4,XMM5
	addps XMM4,XMM3
	; here, the global rotation matrix is in XMM6, XMM7 and XMM4
	
	
	;
	; here, we transpose the global rotation matrix (in XMM6, XMM7 et XMM4) to increase speed calc after...
	;
	movaps XMM5,XMM6
	movlhps XMM5,XMM7
	movhlps XMM7,XMM6
	movaps XMM6,XMM5
	shufps XMM5,XMM4,0C8h
	shufps XMM6,XMM4,0DDh
	shufps XMM7,XMM4,0E8h
	; here, the global rotation matrix is in XMM5, XMM6 and XMM7
	
	
	;
	; here, we calc a simple point (with our matrix in XMM5, XMM6 and XMM7)
	; after the global matrix is calculated, you just need to repeat this operation for every points
	;
	movaps XMM0,OWORD PTR [edx]
	movaps XMM1,XMM0
	movaps XMM2,XMM0
	shufps XMM0,XMM0,000h
	shufps XMM1,XMM1,055h
	shufps XMM2,XMM2,0AAh
	mulps XMM0,XMM5
	mulps XMM1,XMM6
	mulps XMM2,XMM7
	addps XMM0,XMM1
	addps XMM0,XMM2
	; here, XMM0 = _,newZ,newY,newX
	
	ret
nwGlobalRotation endp

fEnableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER 
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGL endp

fEnableOpenGLBitmap proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_SUPPORT_OPENGL or PFD_SUPPORT_GDI or PFD_DRAW_TO_BITMAP
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGLBitmap endp

fDisableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	
	invoke wglMakeCurrent,0,0
	mov edx,lpwRC
	invoke wglDeleteContext,[edx]
	ret
fDisableOpenGL endp



fDrawTri proc uses esi edi lpfTri:dword,nFlag:dword
	LOCAL nIndex:dword
	LOCAL texture:dword
	
	mov esi,lpfTri
	
	
	
	invoke glEnable,GL_TEXTURE_2D
	invoke glBindTexture,GL_TEXTURE_2D,[esi].fTri.TexID
	
	;jmp @f
	xor ecx,ecx
	loop_each_vertex:
	pushad
		inc ecx
		mov nIndex,ecx
		invoke glBegin,nFlag
			invoke fTriGetVertexData,lpfTri,nIndex
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,1
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,2
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
		invoke glEnd
	popad
	add ecx,3
	cmp ecx,[esi].fTri.nVertex
	jl loop_each_vertex
	@@:
	
;	invoke glBegin,GL_QUADS
;		invoke glTexCoord2f,CFLT(0.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(1.0)
;		invoke glTexCoord2f,CFLT(0.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(1.0)
;	invoke glEnd
	
	invoke glBindTexture,GL_TEXTURE_2D,0
	
	ret
fDrawTri endp